'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lezer = require('lezer');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lezer.Parser.deserialize({
  version: 13,
  states: "!|QYQPOOObQPO'#ChOvQPO'#CeOOQO'#Cl'#ClQYQPOOOYQPO,58zOYQPO,58zOYQPO,58zOYQPO,59POOQO-E6f-E6fOOQO1G.f1G.fO!aQPO1G.fO!hQPO1G.fO!oQPO1G.kOOQO7+$V7+$V",
  stateData: "!}~O_OSPOS~ORROYQO~OTTOUUOVVOR[XY[X][X~OZWO~OTTORSiVSiYSi]SiWSi~OUSi~P{OUUO~P{OTTOUUOVVOW^O~O",
  goto: "!QaPPPPbPPPPbPPjPPPp]ROSTUVWQSORXSSPOSQYTQZUQ[VR]W",
  nodeNames: "⚠ LineComment Program String BinaryExpression CompareOp LogicAnd LogicOr ) Function Keyword (",
  maxTerm: 16,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: ")k~RkXY!vYZ!v]^!vpq!vqr#Xrs#dxy$Ryz$W}!O$]!Q![$]!]!^$q!^!_$|!_!`#X!`!a$|!c!d%U!d!q$]!q!r&r!r!}$]#R#S$]#T#U't#U#V$]#V#W(h#W#h$]#h#i)P#i#m$]#m#n(h#n#o$]~!{S_~XY!vYZ!v]^!vpq!v~#[P!_!`#_~#dOT~~#gTOr#drs#vs#O#d#O#P#{#P~#d~#{OR~~$OPO~#d~$WOZ~~$]OW~~$bTR~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~$vQP~OY$qZ~$q~%RPT~!_!`#_~%ZVR~}!O$]!Q![$]!c!p$]!p!q%p!q!}$]#R#S$]#T#o$]~%uVR~}!O$]!Q![$]!c!f$]!f!g&[!g!}$]#R#S$]#T#o$]~&cTU~R~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~&wVR~}!O$]!Q![$]!c!t$]!t!u'^!u!}$]#R#S$]#T#o$]~'eTV~R~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~'yWR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#i$]#i#j(h#j#o$]~(hOY~~(mUR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#o$]~)UVR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#U(h#U#o$]",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const papershiveLanguage = language.LezerLanguage.define({
    parser: parser.configure({
        props: [
            language.foldNodeProp.add({
                BinaryExpression: language.foldInside,
                Function: language.foldInside
            }),
            highlight.styleTags({
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren,
                LogicAnd: highlight.tags.operatorKeyword,
                LogicOr: highlight.tags.operatorKeyword,
                CompareOp: highlight.tags.compareOperator,
                Keyword: highlight.tags.keyword
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
const papershiveCompletion = papershiveLanguage.data.of({
    autocomplete: autocomplete.completeFromList([
        {
            label: "au:",
            type: "function",
            detail: "Authors",
            apply: 'au:("")'
        },
        { label: "a:", type: "function", detail: "Abstracts", apply: 'a:("")' },
        { label: "t:", type: "function", detail: "Titless", apply: 't:("")' },
        {
            label: "ta:",
            type: "function",
            detail: "Titles and Abstracts",
            apply: 'ta:("")'
        },
        { label: "c:", type: "function", detail: "Citations", apply: 'c:("")' },
        { label: "y:<", type: "function", detail: "Published before year" },
        { label: "y:>", type: "function", detail: "Published after year" },
        {
            label: "y:<=",
            type: "function",
            detail: "Published before and including year"
        },
        {
            label: "y:>=",
            type: "function",
            detail: "Published after and including year"
        },
        {
            label: "AND",
            type: "logicOperator"
        },
        { label: "OR", type: "logicOperator" }
    ])
});
function papershive() {
    return new language.LanguageSupport(papershiveLanguage, [papershiveCompletion]);
}

exports.papershive = papershive;
exports.papershiveCompletion = papershiveCompletion;
exports.papershiveLanguage = papershiveLanguage;
